<?php 

namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\FilterCriteria;  

class ConsumidorCliente extends CrudWithParameterBag {
    
    protected $parameterBagColumns  = array('NRORG', 'CDCLIENTE'),
              $dataSourceName       = 'select_consumidorCliente';
              
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $conditions = $request->getFilterCriteria()->getConditions();
        
        foreach($conditions as &$data){
            $conditions[1]['columnName'] = 'CDCLIENTE';
            if($data['columnName'] == 'CDCLIENTE'){
                $data['value'] = implode('_',  $data['value']);
            }
        }
        $newRequest = new DTO\Request\Filter(
            new FilterCriteria(
                $request->getFilterCriteria()->getDataSourceName(),
                $conditions,
                $request->getFilterCriteria()->getPage(),
                $request->getFilterCriteria()->getPageSize()
            ),
            $request->getMethod(),
            $request->getRoutePath(),
            $request->getUserId()
        );
        parent::find($newRequest, $response);
    }
    
    
    public function findConsumidorCliente(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = 'consumidorCliente';
        $this->parameterBagColumns = array('NRORG', 'CDCLIENTE', 'CDFILIAL', 'P_TCDCLIENTE');
        $conditions = $request->getFilterCriteria()->getConditions();
        if(count($conditions) > 0){
            $conditions[3]['columnName'] = 'P_TCDCLIENTE';
            $conditions[3]['value'] = '';
            $conditions[3]['operator'] = '=';
            foreach($conditions as $key => $value){
                if($value['columnName'] == 'CDCLIENTE'){
                    if(is_array($value['value']) && (count($value['value']) > 0)){
                        $array_cliente = $value['value'];
                        unset($conditions[$key]['value']);
                        $conditions[$key]['value'] =  implode('_', $array_cliente);    
                    }else{
                        $conditions[3]['value'] = 'T';
                    }
                }
                if($value['columnName'] == 'CDFILIAL'){
                    if(is_array($value['value']) && (count($value['value']) > 0)){
                        $array_filial = $value['value'];
                        unset($conditions[$key]['value']);
                        $conditions[$key]['value'] =  implode('_', $array_filial);    
                    }
                }
            }
        }
        
        $newRequest = new DTO\Request\Filter(
            new FilterCriteria(
                $request->getFilterCriteria()->getDataSourceName(),
                $conditions,
                $request->getFilterCriteria()->getPage(),
                $request->getFilterCriteria()->getPageSize()
            ),
            $request->getMethod(),
            $request->getRoutePath(),
            $request->getUserId()
        );
        
        parent::find($newRequest, $response);
    }

}   