<?php
namespace Teknisa\MAN\Controllers;

use \Teknisa\Libs\Utilities\Environment;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\FilterCriteria;

class ConsumidorSelect extends \Teknisa\MAN\Controllers\TeknisaCrud {
    
    protected $dataSourceName = "consumidorSelect";
    protected $parameterBagColumns = ["NRORG", "CDCLIENTE"];
    
    public function findConsumidor(DTO\Request\Filter $request, DTO\Response $response) {
        
        $filterCriteria = $request->getFilterCriteria();
        $conditions = $filterCriteria->getConditions();
        if(!empty($conditions)){
            foreach($conditions as $key => $value){
                if($value['columnName'] == 'CDCLIENTE' && !empty($conditions[$key]['value'])){
                    $conditions[$key]['value'] = $conditions[$key]['value'];   
                    $conditions[$key]['operator'] = '=';   
                }
            }   
        }
        
        $newRequest = new DTO\Request\Filter(
            new FilterCriteria(
                $request->getFilterCriteria()->getDataSourceName(),
                $conditions,
                $request->getFilterCriteria()->getPage(),
                $request->getFilterCriteria()->getPageSize()
            ),
            $request->getMethod(),
            $request->getRoutePath(),
            $request->getUserId()
        );
        
        
        parent::find($newRequest, $response);
    }
}